---
title: XPathExpression.evaluate()
slug: Web/API/XPathExpression/evaluate
tags:
  - API
  - DOM XPath API
  - Method
  - Reference
  - XPath
  - XPathExpression
---
<div>{{APIRef("DOM XPath")}}</div>

<p>The <strong><code>evaluate()</code></strong> method of the {{domxref("XPathExpression")}} interface executes an <a href="/en-US/docs/Web/XPath">XPath</a> expression on the given node or document and returns an {{domxref("XPathResult")}}.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">XPathResult <var>node</var>.evaluate(contextNode, type, result);
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt>contextNode</dt>
 <dd>A {{domxref("Node")}} representing the context to use for evaluating the expression.</dd>
 <dt>type {{optional_inline}}</dt>
 <dd>Specifies the type of result to be returned by evaluating the expression. This must be one of the {{domxref("XPathResult", "XPathResult", "Constants")}}.</dd>
 <dt>result {{optional_inline}}</dt>
 <dd>Allows to specify a result object which may be reused and returned by this method. If this is specified as <code>null</code> or the implementation does not reuse the specified result, a new result object will be returned.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>An {{domxref("XPathResult")}} object representing the result of evaluating the XPath expression.</p>

<h3 id="Exceptions">Exceptions</h3>

<h4 id="INVALID_EXPRESSION_ERR">INVALID_EXPRESSION_ERR</h4>

<p>If the expression is not legal according to the rules of the {{domxref("XPathEvaluator")}}, an {{domxref("XPathException")}} of type <code>INVALID_EXPRESSION_ERR</code> is raised.</p>

<h4 id="TYPE_ERR">TYPE_ERR</h4>

<p>In case result cannot be converted to the specified type, an {{domxref("XPathException")}} of type <code>TYPE_ERR</code> is raised.</p>

<h4 id="NAMESPACE_ERR">NAMESPACE_ERR</h4>

<p>If the expression contains namespace prefixes which cannot be resolved by the specified {{domxref("XPathNSResolver")}}, a {{domxref("DOMException")}} of type <code>NAMESPACE_ERROR</code> is raised.</p>

<h4 id="WRONG_DOCUMENT_ERR">WRONG_DOCUMENT_ERR</h4>

<p>If the provided context node is from a document that is not supported by the {{domxref("XPathEvaluator")}}, a {{domxref("DOMException")}} of type <code>WRONG_DOCUMENT_ERR</code> is raised.</p>

<h4 id="NOT_SUPPORTED_ERR">NOT_SUPPORTED_ERR</h4>

<p>If the provided context node is not a type permitted as an XPath context node or the request type is not permitted by the {{domxref("XPathEvaluator")}}, a {{domxref("DOMException")}} of type <code>NOT_SUPPORTED_ERR</code> is raised.</p>

<h2 id="Example">Example</h2>

<p>The following example shows the use of the <code>evaluate()</code> method.</p>

<h3 id="HTML">HTML</h3>

<pre class="brush: html">&lt;div&gt;XPath example&lt;/div&gt;
&lt;div&gt;Number of &amp;lt;div&amp;gt;s: &lt;output&gt;&lt;/output&gt;&lt;/div&gt;
</pre>

<h3 id="JavaScript">JavaScript</h3>

<pre class="brush: js">var xpath = "//div";
var evaluator = new XPathEvaluator();
var expression = evaluator.createExpression("//div");
var result = expression.evaluate(document, XPathResult.ORDERED_NODE_SNAPSHOT_TYPE);
document.querySelector("output").textContent = result.snapshotLength;
</pre>

<h3 id="Result">Result</h3>

<p>{{EmbedLiveSample('Example', 400, 70)}}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName("DOM3 XPath", "xpath.html#XPathExpression-evaluate", "XPathExpression.evaluate()")}}</td>
   <td>{{Spec2("DOM3 XPath")}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.XPathExpression.evaluate()")}}</p>
</div>
